import React from 'react';
import classnames from 'classnames';
import compose from 'lodash/fp/compose';
import curryN from 'lodash/fp/curryN';
import { parseMetadata } from '@highlight-ui/utils-commons';
import { Icon } from '@highlight-ui/icon';

/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign$1 = function() {
    __assign$1 = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign$1.apply(this, arguments);
};

function __spreadArray(to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
}

var styles$1 = {"pagination":"Pagination-module__2H3nOfON__v2-0-21","page":"Pagination-module__29JdyONz__v2-0-21","pageButton":"Pagination-module__352g20q4__v2-0-21","active":"Pagination-module__2pIiLAwQ__v2-0-21"};

function calcMaxPage(limit, total) {
    return Math.ceil(total / limit);
}

function calcPage(limit, offset) {
    return Math.ceil((offset + limit) / limit);
}

function calcCenterPagePosition(maxItems) {
    return Math.ceil(maxItems / 2);
}

function getPrevNumberList(acc, num, limit) {
    return num <= 1 || limit < 1
        ? acc
        : getPrevNumberList(__spreadArray([num - 1], acc, true), num - 1, limit - 1);
}

function incrementList(acc, maxLength, limit, page) {
    return acc.length >= maxLength || page > limit
        ? acc
        : incrementList(__spreadArray(__spreadArray([], acc, true), [page], false), maxLength, limit, page + 1);
}

function calcOffset(limit, page) {
    return page * limit - limit;
}

function getPageFromEvent(e) {
    var _a;
    return (_a = e.currentTarget.dataset.page) !== null && _a !== void 0 ? _a : '';
}

var Nav = function (_a) {
    var buttonClassName = _a.buttonClassName, className = _a.className, page = _a.page, icon = _a.icon, onClick = _a.onClick;
    return (React.createElement("li", __assign$1({ className: className }, parseMetadata({ testId: 'pagination-nav' })),
        React.createElement("a", { role: "button", "data-page": page, onClick: onClick, className: buttonClassName },
            React.createElement(Icon, { name: icon }))));
};

/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __rest(s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
}

var styles = {"fontFamily":"Typography-module__3vNPOCvt__v3-0-21","heading-1":"Typography-module__3Z0Oot5O__v3-0-21","heading-2":"Typography-module__1JbxWZF3__v3-0-21","heading-3":"Typography-module__2xWY5JDF__v3-0-21","heading-4":"Typography-module__2LqCsgLQ__v3-0-21","subtitle-1":"Typography-module__13OtDNn___v3-0-21","subtitle-2":"Typography-module__1vaNFaoa__v3-0-21","subtitle-3":"Typography-module__OU90cvvz__v3-0-21","subtitle-4":"Typography-module__1gRqi1a1__v3-0-21","body-1":"Typography-module__2uoDh7Lc__v3-0-21","button-1":"Typography-module__1KnOaXLm__v3-0-21","caption-1":"Typography-module__2gU8wbJ6__v3-0-21","caption-2":"Typography-module__3lmxW6P0__v3-0-21","overline-1":"Typography-module__2-d12Wsw__v3-0-21"};

var variantMapping = {
    'heading-1': 'h1',
    'heading-2': 'h2',
    'heading-3': 'h3',
    'heading-4': 'h4',
    'subtitle-1': 'h6',
    'subtitle-2': 'h6',
    'subtitle-3': 'h6',
    'subtitle-4': 'h6',
    'body-1': 'p',
    'button-1': 'span',
    'caption-1': 'span',
    'caption-2': 'span',
    'overline-1': 'span',
};
var TypographyWithRef = function (_a, ref) {
    var children = _a.children, className = _a.className, component = _a.component, variant = _a.variant, otherProps = __rest(_a, ["children", "className", "component", "variant"]);
    var tag = component || variantMapping[variant];
    return React.createElement(tag, __assign(__assign({}, otherProps), { ref: ref, className: classnames(styles[variant], className, styles.fontFamily) }), children);
};
TypographyWithRef.displayName = 'Typography';
var Typography = React.forwardRef(TypographyWithRef);

var Pagination = React.forwardRef(function (_a, ref) {
    var className = _a.className, metadata = _a.metadata, _b = _a.firstPageIconName, first = _b === void 0 ? 'angle-double-left' : _b, _c = _a.prevPageIconName, prev = _c === void 0 ? 'angle-left' : _c, _d = _a.nextPageIconName, next = _d === void 0 ? 'angle-right' : _d, _e = _a.lastPageIconName, last = _e === void 0 ? 'angle-double-right' : _e, limit = _a.limit, _f = _a.maxItems, maxItems = _f === void 0 ? 0 : _f, offset = _a.offset, onChange = _a.onChange, total = _a.total;
    var maxPage = calcMaxPage(limit, total);
    var page = calcPage(limit, offset);
    var centerIndex = calcCenterPagePosition(maxItems);
    var previousPages = getPrevNumberList([], page, centerIndex - 1);
    var displayList = incrementList(previousPages, maxItems, maxPage, page);
    var getOffsetOf = curryN(2, calcOffset)(limit);
    var onPaginate = compose([
        onChange,
        getOffsetOf,
        Number,
        getPageFromEvent,
    ]);
    return (React.createElement("ul", __assign$1({ className: classnames(styles$1.pagination, className), ref: ref }, parseMetadata(metadata)),
        page > 1 && (React.createElement(React.Fragment, null,
            React.createElement(Nav, { page: 1, icon: first, onClick: onPaginate, className: styles$1.page, buttonClassName: styles$1.pageButton }),
            React.createElement(Nav, { page: page - 1, icon: prev, onClick: onPaginate, buttonClassName: styles$1.pageButton }))),
        displayList.map(function (innerPage) {
            var _a;
            return (React.createElement("li", { key: innerPage, className: styles$1.page },
                React.createElement("a", __assign$1({}, parseMetadata({ testId: "pagination-page-" + innerPage }), { role: "button", "data-page": innerPage, className: classnames(styles$1.pageButton, (_a = {},
                        _a[styles$1.active] = innerPage === page,
                        _a)), onClick: onPaginate }),
                    React.createElement(Typography, { variant: "button-1", component: "span" }, innerPage))));
        }),
        page < maxPage && (React.createElement(React.Fragment, null,
            React.createElement(Nav, { page: page + 1, icon: next, onClick: onPaginate, buttonClassName: styles$1.pageButton }),
            React.createElement(Nav, { page: maxPage, icon: last, onClick: onPaginate, buttonClassName: styles$1.pageButton })))));
});

export { Pagination };
//# sourceMappingURL=index.js.map
